package com.goafanti.common.dao;

import com.goafanti.admin.bo.AdminStatisticsBo;
import com.goafanti.common.model.AdminCallDay;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.time.LocalDate;
import java.util.List;

/**
 * 外呼每天统计表(AdminCallDay)表数据库访问层
 *
 * @author makejava
 * @since 2024-12-11 09:21:49
 */
public interface AdminCallDayMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    AdminCallDay queryById(Integer id);


    /**
     * 查询指定行数据
     *
     * @param adminCallDay 查询条件
     * @param pageable     分页对象
     * @return 对象列表
     */
    List<AdminCallDay> findAdminCallDayList(AdminCallDay adminCallDay, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param adminCallDay 查询条件
     * @return 总行数
     */
    int findAdminCallDayCount(AdminCallDay adminCallDay);

    /**
     * 新增数据
     *
     * @param adminCallDay 实例对象
     * @return 影响行数
     */
    int insert(AdminCallDay adminCallDay);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<AdminCallDay> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<AdminCallDay> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<AdminCallDay> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<AdminCallDay> entities);

    /**
     * 修改数据
     *
     * @param adminCallDay 实例对象
     * @return 影响行数
     */
    int update(AdminCallDay adminCallDay);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    AdminCallDay selectByAidAndDay(@Param("aid") String aid, @Param("now") LocalDate now);

    void insertDay(@Param("id") String id, @Param("startDate") LocalDate startDate, @Param("endDate") LocalDate endTime);

    void updateDay(@Param("id") String id, @Param("startDate") LocalDate startDate, @Param("endDate") LocalDate endTime);


    AdminStatisticsBo selectByAidCount(@Param("aid") String aid, @Param("startTime") String startTime, @Param("endTime") String endTime);


    void updateTeamId(@Param("id") String id, @Param("teamId") Integer teamId);
}

